// libTorrent - BitTorrent library
// Copyright (C) 2005, Jari Sundell
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Contact:  Jari Sundell <jaris@ifi.uio.no>
//
//           Skomakerveien 33
//           3185 Skoppum, NORWAY

#ifndef LIBTORRENT_UTILS_TASK_SCHEDULE_H
#define LIBTORRENT_UTILS_TASK_SCHEDULE_H

#include <list>

#include "timer.h"

namespace torrent {

class Task;

class TaskSchedule {
public:
  friend class Task;

  typedef std::list<Task*>    Container;
  typedef Container::iterator iterator;

  static void         perform(Timer t);

  static Timer        get_timeout();

protected:
  static iterator     end()               { return m_container.end(); }

  static iterator     insert(Task* t);
  static void         erase(iterator itr) { m_container.erase(itr); }

private:
  static inline void  execute_task(Task* t);

  static Container    m_container;
};

}

#endif
